<form name="create_form" novalidate ng-submit="createForm()">
    <div class="modal-header">
        <h3 class="modal-title">Add a User</h3>
    </div>
    <div class="modal-body">
        <div class="form-group">
            <label for="fname">First Name:</label>
            <input type="text" id="fname"
                   placeholder="First Name"
                   class="form-control"
                   name="fname"
                   ng-model="create.fname"
                   ng-minlength=3
                   ng-maxlength=20
                   ng-class="{error: create_form.fname.$dirty && create_form.fname.$invalid}"
                   required />

            <div class="error" ng-show="create_form.fname.$dirty && create_form.fname.$invalid && !create_form.fname.$focused">
                <small class="error" ng-show="create_form.fname.$error.required">Your name is required.</small>
                <small class="error" ng-show="create_form.fname.$error.minlength">Your name is required to be at least 3 characters</small>
                <small class="error" ng-show="create_form.fname.$error.maxlength">Your name cannot be longer than 20 characters</small>
            </div>
        </div>
        <div class="form-group">
            <label for="lname">Last Name:</label>
            <input type="text" id="lname"
                   placeholder="Lst Name"
                   class="form-control"
                   name="lname"
                   ng-model="create.lname"
                   ng-minlength=3
                   ng-maxlength=20
                   ng-class="{error: create_form.lname.$dirty && create_form.lname.$invalid}"
                   required />

            <div class="error" ng-show="create_form.lname.$dirty && create_form.lname.$invalid && !create_form.lname.$focused">
                <small class="error" ng-show="create_form.lname.$error.required">Your name is required.</small>
                <small class="error" ng-show="create_form.lname.$error.minlength">Your name is required to be at least 3 characters</small>
                <small class="error" ng-show="create_form.lname.$error.maxlength">Your name cannot be longer than 20 characters</small>
            </div>
        </div>
        <div class="form-group">
            <label for="email">Email address:</label>
            <input type="email" id="email"
                   placeholder="Email address"
                   class="form-control"
                   name="email"
                   ng-model="create.email"
                   ensure-unique="email"
                   ng-class="{error: create_form.email.$dirty && create_form.email.$invalid}"
                   required />

            <div class="error" ng-show="create_form.email.$dirty && create_form.email.$invalid && !create_form.email.$focused">
                <small class="error" ng-show="create_form.email.$error.required">Your name is required.</small>
                <small class="error" ng-show="create_form.email.$error.email">That is not a valid email. Please input a valid email.</small>
                <small class="error" ng-show="create_form.email.$error.unique">That email is taken, please try another</small>
            </div>
        </div>
        <div class="form-group">
            <label for="role">Role:</label>
            <select required id="role" name="role" class="form-control" ng-options="o.name for o in ::roles" ng-model="create.role"></select>
        </div>
        <div class="checkbox">
            <label><input ng-checked="create.active === 1" name="active" ng-model="create.active" type="checkbox"> Active</label>
        </div>
    </div>
    <div class="modal-footer">
        <button class="btn btn-primary" type="submit" ng-disabled="create_form.$invalid">OK</button>
        <button class="btn btn-warning" type="button" ng-click="cancel()">Cancel</button>
    </div>
</form>